#!/usr/bin/perl

#################################################################################################
#chat.pl v2.00 -- December 18, 1996
#
#A script to allow the operation of one chat room or many chat rooms.
#
#This script handles:
#	-logging in and out
#	-speech
#	-clear screen
#	-redirect(on log out)
#	-kicking out/banishing users
#
#Written by Bernard Sowa <bernard@zonecoaster.com>
#
#Please do not redistribute this script.
#
#	Disclaimer: I am in no way responsible for any damage this script may cause to anything
#		    which has anything to do with you.
#################################################################################################

#################################################################################################
#Configuration Section
#
#$basedir
#	Absolute system path for directory containing all of the chat files(html files), the file
#	specified in $banishfile, and the one specified in $addressfile
#
#	Note:  *All* of the HTML files, the file specified in $banishfile, and the file specified
#		in $addressfile *MUST* be in $basedir.  The only exception is the HTML file from which
#		a user logs in to a chat room
#
#$banishfile
#	File containing the IP addresses of all users who have been permanently banished from the chat room.
#	Place it in $basedir.
#
#$addressfile
#	Name of file temporarily containing IP addresses of users
#	Place it in $basedir.
#
#$title
#	The title of the chat room/area.
#
#%rooms
#	Associative array containing chat room names(value="whatever" from your log in form)
#	and their associated files.  
#	Example:  <option value="sports">
#		  <option value="politics">
#
#	Say the chat files(where comments go) are called sports.html and politics.html.
#	The array would look like the following:
#
#	%rooms=('sports','sports.html','politics','politics.html')
#
#%users
#	Associative array containing chat room names(value="whatever" from your log in form)
#	and the logon lists associated with them(lists of people logged into chat room)
#	Example:  <option value="sports">
#		  <option value="politics">
#
#	Say the user lists are called sportsusers.html and politicsusers.html.
#	The array would look like the following:
#
#	%users=('sports','sportsusers.html','politics','politicsusers.html')
#
#
#	NOTE: The headings(ex. sports and politics, should be the same for %rooms and
#	      %users but the html files should be different since those in %rooms contain
#	      the actual discussion dialogue and those in %users contain lists of users
#	      in each room.
#
#%choices
#	Associative Array containing a list of "handles" for rooms, followed by the names
#	you would like to give those rooms in the drop-down list of rooms to choose from
#	which the user sees on the logon page.
#
#	Every second item(1,3,5...) is the same as the ones you used for %rooms.  Every
#	other second item(2,4,6...) is just what you'd like to call that room(ie: the
#	title of the room.
#
#$firstchoice
#	The "handle" for the room that you want to be highlighted when the user loads the
#	logon form.  If the user makes no changes and just selects "Enter Room," the 
#	user enter this room.
#
#$chatmaster
#	The logon of the person in control of the chat room uses
#	If you use this logon it will be automatically translated into "Chat Room Admin"
#	when you speak and in the user list.
#
#$password
#	The chat room admin's password. This is used for emptying the rooms without
#	actually entering them.
#
#$valid
#	Valid URLs which can call the script...so people can't make their own
#	forms and use your script.
#
#$save
#	Set to 'yes' if you'd like the a file to be created(name is current time and date)
#	whenever the Chat Room Admin clears the screen
#
#$archive
#	This is where the files are saved to if you set $save to 'yes'
#
#$privatedir
#	Directory to store private messages in.
#
#$imagedir
#	Directory to load images from.(Must be browser-accessible)
#
#$imageurl
#	URL for this directory.
#
#$allowimages
#	Whether or not to allow users to choose images to use.
#
#$maxlines
#	Maximum number of lines to allow in a chat room file...to prevent
#	the files from getting too big when you're not around to clear the screen.
#
#$body
#	Body tag to use for the log on page and the administration page.
#
#$meta
#	The refresh tag from the chat rooms. Put -XX- where the number of
#	seconds would normally go.
#################################################################################################

$basedir = '/home/httpd/elvis/public_html/chat4/';
$banishfile = 'banished.txt';
$addressfile = 'addresses.txt';
$title = "Oh Yeah Net's Chat Rooms";
$cgiurl = 'http://linux.cqi.com.cn/~elvis/chat4/chat.pl';
$cgiurl2 = 'http://linux.cqi.com.cn/~elvis/chat4/chatctrl.pl';
$cgiurl3 = 'http://linux.cqi.com.cn/~elvis/chat4/chatfunc.pl';
$chatmaster = 'elvis';
$password = '1234';
%rooms = ('one','comments.html','two','comments2.html');
%users = ('one','logon.html','two','logon2.html');
%choices = ('one','Room 1 -- Open Discussion','two','Room 2 -- Open Discussion');
$firstroom = "one";
$valid = 'http://linux.cqi.com.cn/~elvis/chat4/';
$save='no';
$archive='/home/httpd/elvis/public_html/chat4/archive/';
$privatedir = '/home/httpd/elvis/public_html/chat4/private/';
$imagedir = '/home/httpd/elvis/public_html/chat4/images/';
$imageurl = 'http://linux.cqi.com.cn/~elvis/chat4/images/';
$allowimages = 'no';
$maxlines = '70';
$body = "<body background=\"http://linux.cqi.com.cn/~elvis/bg1.gif\" bgcolor=\"\#ffffff\" text=\"\#000000\" link=\"\#a0785d\" vlink=\"\#6E0000\">\n";
$meta='<META HTTP-EQUIV="Refresh" CONTENT=08>';

#################################################################################################
#Show logon form
#################################################################################################

if($ENV{'QUERY_STRING'} eq "logon")
{
	print "Content-type: text/html\n\n";
	print "<html>\n";
	print "<title>Log into chat area</title>\n";
	print "$body";
	print "<h2>$title</h2><br>\n";
	print "<p>To send a private message, select the <b>private</b>checkbox and precede the message with the username of the person \n";
	print "you wish to send a message to.(Ex:<i>jdoe:Let's keep this conversation on the down-low</i>  ---- sends private message to user jdoe)\n";
	print "<br><br>\n";
	print "<table border=0>\n";
	print "<form method=post action=\"$cgiurl\">\n";
	print "<tr><td><b>Desired Nickname:</b></td><td><input type=text name=\"logon\" maxlength=20>(Alphanumeric characters only)</td></tr>\n";
	print "<tr><td><b>Email Address(optional)</b>:</td><td><input type=text name=\"email\"></td></tr>\n";
	print "<tr><td><b>Chat Room</b>:</td>\n";
	print "<td>\n";
	print "<select name=\"room\">\n";
	foreach $key (sort keys(%choices))
	{
		if($key eq $firstroom)
		{
			print "<option value=\"$key\" SELECTED>$choices{$key}</option>\n";
		}
		else
		{
			print "<option value=\"$key\">$choices{$key}</option>\n";
		}
	}
	print "</select>\n";
	print "</td></tr>\n";
	print "</table>\n";
	print "<br>\n";
	print "<table border=1>\n";
	print "<tr><td><center>Room</center></td><td><center>Number of People</center></td></tr>\n";
	foreach $key (sort keys(%choices))
	{
		push(@total,$choices{$key},$users{$key});
	}
	#@total looks like this:
	#@total=('Room 1 -- Open Discussion','logon.html','Room 2 -- Open Discussion','logon2.html');
	%total=@total;
	foreach $key (keys (%total))
	{
		open(FILE,"$basedir$total{$key}");
		@contents=<FILE>;
		close(FILE);
		
		$count=0;
		foreach $line (@contents)
		{
			if($line =~ /mailto/)
			{
				++$count;
			}
		}
		print "<tr><td>$key</td><td><center>$count</center></td></tr>\n";
	}
	print "</table>\n";
	if($allowimages eq "yes")
	{
		print "<br><b>Select an avatar.</b><br><br>\n";

		print "<input type=hidden name=\"action\" value=\"Log On\">\n";
		print "<input type=submit value=\"Enter Chat Room\">\n";

		opendir(DIR,"$imagedir") || die "Content-type: text/html\n\n<html>Could not open $imagedir</html>";
		@images=grep(/\.gif/,readdir(DIR));
		close(DIR);

		$i="1";
		foreach $image (@images)
		{
			if($i =~ /^(7|14|21|28)/)
			{
				print "<br>\n";
			}
			if($i eq "1")
			{
				print "<input type=radio name=\"image\" value=\"$image\" CHECKED><img src=\"$imageurl$image\">\n";
			}
			else
			{
				print "<input type=radio name=\"image\" value=\"$image\"><img src=\"$imageurl$image\">\n";
			}
			++$i;
		}
		print "<input type=radio name=\"image\" value=\"NONE\">No Avatar.\n";
		print "<br>\n";
	}
	else
	{
		print "<input type=hidden name=\"action\" value=\"Log On\">\n";
		print "<input type=hidden name=\"image\" value=\"NONE\">\n";
		print "<br><br><input type=submit value=\"Enter Chat Room\">\n";
	}
	print "<br>\n";
	print "<br><br>\n";
	print "</form>\n";
	print "<center>This script can be obtained from <a href=\"http://www.zonecoaster.com/\">The Zone Coaster</a></center>\n";
	print "</html>\n";
	exit 0;
}

#################################################################################################
#Clear rooms without entering them.
#################################################################################################

if($ENV{'QUERY_STRING'} eq "admin")
{
	print "Content-type: text/html\n\n";
	print "<html>\n";
	print "<title>Administer The Chat Rooms</title>\n";
	print "$body";
	print "<form action=\"$cgiurl\" method=POST>\n";
	print "<b>Password</b>: <input type=password name=\"password\">\n";
	print "<input type=submit name=\"action\" value=\"Empty All Rooms\">\n";
	print "</form>\n";
	print "</html>\n";
	exit 0;
}

#################################################################################################
#Get form information
#################################################################################################

if($ENV{'HTTP_REFERER'} !~ /$valid/)
{
	if($ARGV[0] eq "")
	{
		&go_away;
	}
}

if($ARGV[0] ne "")
{
	push(@formdata,'logon',$chatmaster,'email','nothing','room','one','action','Log On');
	%formdata = @formdata;
}
else
{
	$buffer = "";
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs=split(/\&/,$buffer);
	&get_form_data;
}

#set some time stuff up
$time = scalar localtime time;
@time = split(/ /,$time);
foreach $item (@time)
{
	if($item =~ /\:/)
	{
		$time = $item;
	}
}

##########################################################################################
#Empty All Rooms
##########################################################################################

if ($formdata{'action'} eq "Empty All Rooms")				#empty all chat rooms.
{
	if($formdata{'password'} ne "$password")
	{
		&wrong_pass;
	}

	#Remove addresses from address file
	open(FILE,">$basedir$addressfile") || &unable("$basedir$addressfile");
	close(FILE);

	#Empty the chat room user lists.
	foreach $key (keys(%users))
	{
		open(FILE,"$basedir$users{$key}") || &unable("$basedir$users{$key}");
		@contents=<FILE>;
		close(FILE);

		open(FILE,">$basedir$users{$key}") || &unable("$basedir$users{$key}");
		foreach $line (@contents)
		{
			if($line !~ /^<a href=\"mailto\:/)
			{
				print FILE $line;
			}
		}
		close(FILE);
	}

	#Erase all private message files
	opendir(DIR,"$privatedir") || &unable("$privatedir");
	@mess=grep(/\.html/,readdir(DIR));
	close(DIR);
	foreach $thing (@mess)
	{
		push(@messages,$thing);
	}
	@mess=grep(/\.txt/,readdir(DIR));
	close(DIR);
	foreach $thing (@mess)
	{
		push(@messages,$thing);
	}
	foreach $message (@messages)
	{
		unlink("$privatedir$message");
	}

	#Clear the screen in all chat rooms
	$start = '<!--Do not edit past this line-->';
	foreach $key (keys(%rooms))
	{
		$done="no";
		open(FILE,"$basedir$rooms{$key}") || &unable("$basedir$rooms{$key}");	#open main chat file
		@contents=<FILE>;							#get contents
		close(FILE);

		open(FILE,">$basedir$rooms{$key}") || &unable("$basedir$rooms{$key}");
		foreach $line (@contents)
		{
			if ($line =~ /$start/)
			{
				print FILE "$line";
				$done="yes";
			}
			if($done ne "yes")
			{
				print FILE "$line";
			}
		}
		close(FILE);
	}
	print "Content-type: text/html\n\n";
	print "<html>\n";
	print "<title>Chat Rooms Empty</title>\n";
	print "$body";
	print "The chat rooms have all been emptied.\n";
	print "</html>\n";
	exit 0;
}

##########################################################################################
#Log On
##########################################################################################

if ($formdata{'action'} eq "Log On")					#add user to list and show chat window on logon
{
	&get_room;
	&get_users;

	if($formdata{'logon'} =~ /\W/ | $formdata{'logon'} eq "")	#make sure logon only has alphanumeric characters
	{
		print "Content-type: text/html\n\n";
		print "<html><title>Error</title>\n";
		print "<body bgcolor=\"\#ffffff\" text=\"\#000000\">\n";
		print "The nickname you chose is invalid.\n<p>";
		print "Only alphanumeric characters are allowed\n";
		print "<p>\nPlease go back and try again.\n";
		print "</html>\n";
		exit 0;
	}

	$mail = $formdata{'email'};

	if($formdata{'logon'} ne $chatmaster)		#if it's not the Chat Room Admin, do some checking
	{						#and see if user has been banished from the chat room
		open (FILE,"$basedir$banishfile") || &unable("$basedir$banishfile");
		@contents=<FILE>;
		close (FILE);

		foreach $banished (@contents)
		{
			if($banished =~ /$ENV{'REMOTE_HOST'}\n/)	#if he has, don't let him in
			{
				print "Content-type: text/html\n\n";
				print "<html><title>Sorry, You've Been Banished</title>\n";
				print "<body bgcolor=\"\#ffffff\" text=\"\#000000\">\n";
				print "You have been banished from this chat room.\n";
				print "</html>";
				exit 0;
			}
		}
	}

	open(FILE,"$basedir$userlist") || &unable("$basedir$userlist");
	@contents=<FILE>;
	close(FILE);

	if($formdata{'logon'} ne $chatmaster)		#if the logon isn't the Chat Room Admin's logon
	{						#check if the name is already taken
		foreach $line (@contents)
		{
			if($line =~ /(>$formdata{'logon'}<\/a><br>\n)$/)
			{
				&name_taken;		#if it is taken, let the user know
			}
		}
	}

	if($formdata{'logon'} ne $chatmaster)		#if it's available and it's not the chat room admin
	{						#put it into the array so it can be
							#be printed later

		push(@contents,"<a href\=\"mailto\:$mail\">$formdata{'logon'}</a><br>\n");
	}

	foreach $line (@contents)			#push all users into one array and put
	{						#other info in another
		if ($line =~ /(<\/a><br>\n)$/)
		{
			push(@users,$line);
		}
		else
		{
			push(@top,$line);
		}
	}

	foreach $user (@users)
	{
		@a = split(/\>/,$user);			#now we've got to sort the user list somehow
		$b = $a[1];				#<a href="mailto:..."></a> tag is the problem
		@c = split(/\</,$b);			#so we'll just get rid of the tags
		push(@userspre,$c[0]);			#there...extracted the users' name
	}

	if($formdata{'logon'} eq $chatmaster)
	{
		push(@realuserlist,"<font size\=\-1><b><a href\=\"mailto\:$mail\">Chat Room Admin</a></b></font><p>\n");
	}

	foreach $shortusername (sort(@userspre))
	{
		foreach $user (@users)
		{
			if ($user =~ /\>$shortusername<\/a><br>\n/)
			{
				push (@realuserlist,$user);
			}
		}
	}

	open(FILE,">$basedir$userlist") || &unable("$basedir$userlist");	#print new version of logon file
	print FILE @top;
	print FILE @realuserlist;
	close(FILE);

	open (FILE,"$basedir$room") || &unable("$basedir$room");		#get contents of commentfile so you can let
	@contents=<FILE>;										#everybody know somebody just arrived
	close (FILE);

	open (FILE,">$basedir$room") || &unable("$basedir$room");
	foreach $line (@contents)
	{

		$start = '<!--Do not edit past this line-->';

		if ($line =~ /$start/)
		{
			if($formdata{'logon'} eq $chatmaster)
			{
				print FILE "$line\n\n";
				print FILE "<center><font color=\"\#0000ff\"><b>The Chat Room Admin has joined us<font size=-1>($time)</font></b></font></center><p>";
			}
			else
			{
				print FILE "$line\n\n";
				print FILE "<center><font color=\"\#0000ff\"><b>$formdata{'logon'}($ENV{'REMOTE_HOST'}) has joined us<font size=-1>($time)</font></b></font></center><p>";
			}
		}
		else
		{
			print FILE "$line";
		}
	}
	close (FILE);

	if($formdata{'logon'} ne $chatmaster)
	{
		open (FILE, ">>$basedir$addressfile") || &unable("$basedir$addressfile");		#add user's logon and IP address to the addressfile so he can be banished later if necessary
		{
			print FILE "$formdata{'logon'}\;$ENV{'REMOTE_HOST'}\n";
		}
		close (FILE);
	}

	open(FILE,">$privatedir$formdata{'logon'}\.html");
	print FILE "<html>\n";
	print FILE "<title>Your Private Messages</title>\n";
	print FILE "<body bgcolor=\"\#ffffff\" text=\"\#000000\">\n";
	print FILE "<center><h2>Private Messages</h2></center><br>\n";
	print FILE "<center><form method=get action=\"$cgiurl3\" target=\"private\">\n";
	print FILE "<input type=submit name=\"action\" value=\"Check For New Messages\">\n";
	print FILE "<input type=submit name=\"action\" value=\"Erase All Messages\">\n";
	print FILE "<input type=hidden name=\"logon\" value=\"$formdata{'logon'}\">\n";
	print FILE "</form></center><br>\n";
	print FILE "</html>\n";
	close(FILE);

	&do_chat;
	exit 0;
}

##########################################################################################
#Log Out
##########################################################################################

if ($formdata{'action'} eq "Log Out")			#erase user's name from user list on logout 
{
	&get_users;
	&get_room;

	$start = '<!--Do not edit past this line-->';

	if($formdata{'logon'} ne "Chat Room Admin")
	{
		open(FILE,"$basedir$addressfile") || &unable("$basedir$addressfile");	#He made it w/o being banished so get contents of addressfile
		@contents=<FILE>;			#so we can remove his name
		close(FILE);

		foreach $address (@contents)		#keep every line except his
		{
			if($address ne "$formdata{'logon'};$ENV{'REMOTE_HOST'}\n")
			{
				push (@ok,$address);
			}
		}

		open(FILE,">$basedir$addressfile") || &unable("$basedir$addressfile");	#put back every line except his
		print FILE @ok;
		close(FILE);
	}

	if($formdata{'logon'} ne "Chat Room Admin")
	{
		unlink("$privatedir$formdata{'logon'}\.html");
		unlink("$privatedir$formdata{'logon'}\.txt");
	}
	else
	{
		unlink("$privatedir$chatmaster\.html");
		unlink("$privatedir$chatmaster\.txt");
	}

	open (FILE,"$basedir$userlist") || &unable("$basedir$userlist");		#get contents of the logon file so we can remove
	@contents=<FILE>;				#him from here, too.
	close (FILE);

	open (FILE,">$basedir$userlist") || &unable("$basedir$userlist");
	foreach $line (@contents)
	{
		if($formdata{'logon'} eq "Chat Room Admin")
		{
			if($line =~ /Chat Room Admin/)
			{
			}
			else
			{
				print FILE "$line";
			}
		}
		else
		{
			if ($line =~ /\>($formdata{'logon'}<\/a><br>\n)$/)	#put every line except his
			{
			}
			else
			{
				print FILE "$line";
			}
		}
	}
	close (FILE);

	open (FILE,"$basedir$room") || &unable("$basedir$room");			#get contents of commentfile so we can
	@contents=<FILE>;				#let everybody know somebody's leaving
	close (FILE);

	open (FILE,">$basedir$room") || &unable("$basedir$room");			#print the message that he has left
	foreach $line (@contents)
	{
		if ($line =~ /$start/)
		{
			print FILE "$line\n\n";
			print FILE "<center><font color=\"\#0000ff\"><b>$formdata{'logon'} has left the chat room</b></font></center><p>";
		}
		else
		{
			print FILE "$line";
		}
	}
	close (FILE);

	print "Content-type: text/html\n\n";		#help him get out of the annoying frames
	print "<html><title>Goodbye</title></html>\n";
	print "<body bgcolor=\"\#ffffff\" text=\"\#000000\">\n";
	print "Thank you for participating in this chat.\n<p>\n\n";
	print "To get out of the frames you can just type a location to go ";
	print "to in the text box below and press the button to open it in ";
	print "the full window or you can do it yourself by typing it in ";
	print "your browser's location window.\n<p>\n<center>\n";
	print "<form method=get action=\"$cgiurl\" target=\"_top\">\n";
	print "<input type=text name=\"exit\" size=50>\n";
	print "<input type=submit value=\"Go\">\n";
	print "</form>\n</center>\n";
	print "</html>";
	exit 0;
}

##########################################################################################
#Speak
##########################################################################################

if ($formdata{'action'} eq "speak")
{
	&get_room;
	&get_users;

	if($formdata{'comments'} =~ /^\@kick/ | $formdata{'comments'} =~ /^\@ban/)
	{
		if($formdata{'logon'} eq $chatmaster)
		{
			$start = '<!--Do not edit past this line-->';
			@a=split(/ /,$formdata{'comments'});
			$user=$a[1];		#user to kick out or banish

			open(FILE,"$basedir$userlist") || &unable("$basedir$userlist");
			@contents=<FILE>;
			close(FILE);

			if($user eq "\@all")
			{
				opendir(DIR,"$privatedir") || &unable("$privatedir");
				@messages=grep(/\.html/,readdir(DIR));
				close(DIR);

				foreach $message (@messages)
				{
					if($message !~ /$chatmaster/)
					{
						unlink("$privatedir$message");
						$gh=$message;
						$gh=~s/\.html/\.txt/g;
						unlink("$privatedir$gh");
					}
				}

				open(FILE, ">$basedir$userlist") || &unable("$basedir$userlist");
				foreach $line (@contents)
				{
					if($line =~ /Chat Room Admin/)
					{
						print FILE "$line";
					}
					elsif($line =~ />(.)+<\/a>/)
					{
					}
					else
					{
						print FILE "$line";
					}
				}
				close(FILE);
				open(FILE,">$basedir$addressfile") || &unable("$addressfile");;
				close(FILE);
			}
			else
			{
				open(FILE, ">$basedir$userlist") || &unable("$basedir$userlist");
				foreach $line (@contents)
				{
					if($line =~ /$user<\/a>/)
					{
					}
					else
					{
						print FILE "$line";
					}
				}
				close(FILE);
				unlink("$privatedir$user\.html");
				unlink("$privatedir$user\.txt");
			}

			if($formdata{'comments'} =~ /^\@ban/)
			{
				$status="<center><font color=\"\#ff0000\"><b>$user has been banished from this chat room.</b></font></center><p>";
			}
			else
			{
				if($user eq "\@all")
				{
					$status="<center><font color=\"\#ff0000\"><b>All users have been temporarily kicked out of the chat room.</b></font></center><p>";
				}
				else
				{
					$status="<center><font color=\"\#ff0000\"><b>$user has been temporarily kicked out of the chat room.</b></font></center><p>";
				}
			}
	
			open (FILE, "$basedir$addressfile") || &unable("$basedir$addressfile");		#open addressfile
			@contents=<FILE>;
			close(FILE);
	
			foreach $line (@contents)
			{
				if ($line =~ /$user\;/)			#get line containing user's Nickname and IP address
				{
					$foundit=$line;
				}
				else
				{
					push (@putback,$line);		#save everything else to be put back into the file later
				}
			}

			open(FILE,">$basedir$addressfile") || &unable("$basedir$addressfile");		#open addressfile
			print FILE @putback;				#put stuff back in, but not tossed users' record
			close(FILE);
		
			if($formdata{'comments'} =~ /^\@ban/)
			{
				@addr=split(/\;/,$foundit);		#get IP address of banished user
				$addrs=$addr[1];
				open(FILE,">>$basedir$banishfile") || &unable("$basedir$banishfile");	#open banishfile
				print FILE "$addrs";			#print it in
				close (FILE);
			}

			open (FILE, "$basedir$room") || &unable("$basedir$room");			#open main chat file
			@contents=<FILE>;				#get contents
			close (FILE);

			open (FILE, ">$basedir$room") || &unable("$basedir$room");			#print again with notice that someone's been tossed
			foreach $line (@contents)
			{
				if ($line =~ /$start/)
				{
					print FILE "$line\n\n";
					print FILE "$status";
				}
				else
				{
					print FILE "$line";
				}
			}
			close (FILE);
		}

		$go="$cgiurl3\?room\=$formdata{'room'}\&logon\=$formdata{'logon'}\&action\=Refresh\+Comment\+Window";
		print "Location: $go\n\n";
		exit 0;
	}
	elsif($formdata{'private'})
	{
		@to1=split(/\:/,$formdata{'comments'});
		$to=@to1[0];
		$message=$to1[1];
		if($to =~ /Chat Room Admin/)
		{
			$to="$chatmaster";
		}
		if(-e "$privatedir$to\.html")
		{
			open(FILE,"$privatedir$to\.html");
			@contents=<FILE>;
			close(FILE);

			open(FILE,">$privatedir$to\.html");
			foreach $line (@contents)
			{
				if($line =~ /<\/form><\/center>/)
				{
					print FILE $line;
					if($formdata{'logon'} ne $chatmaster)
					{
						print FILE "<font color=\"\#ff0000\">$formdata{'logon'}:</font> $message<font size = -1>($time)</font>\n<p>";
					}
					else
					{
						print FILE "<font color=\"\#ff0000\">Chat Room Admin:</font> $message<font size = -1>($time)</font>\n<p>";
					}
				}
				else
				{
					print FILE $line;
				}
			}
			close(FILE);
			open(FILE,">$privatedir$to\.txt");
			close(FILE);
		}
		else	#user nonexistent
		{
			open(FILE,"$privatedir$formdata{'logon'}\.html");
			@contents=<FILE>;
			close(FILE);

			open(FILE,">$privatedir$formdata{'logon'}\.html");
			foreach $line (@contents)
			{
				if($line =~ /<\/form><\/center>/)
				{
					print FILE $line;
					print FILE "<font color=\"\#ff0000\">\*\*User <i>$to</i> does not exist.</font>";
				}
				else
				{
					print FILE $line;
				}
			
			}
			close(FILE);
			open(FILE,">$privatedir$formdata{'logon'}\.txt");
			close(FILE);
		}
		$go="$cgiurl3\?room\=$formdata{'room'}\&logon\=$formdata{'logon'}\&action\=Refresh\+Comment\+Window";
		print "Location: $go\n\n";
	}
	elsif($formdata{'comments'} =~ /^\@refresh/)
	{
		if($formdata{'logon'} ne $chatmaster)
		{
			$go="$cgiurl3\?room\=$formdata{'room'}\&logon\=$formdata{'logon'}\&action\=Refresh\+Comment\+Window";
			print "Location: $go\n\n";
			exit 0;
		}
		$refresh=$formdata{'comments'};
		$refresh=~s/\@refresh //g;
		$new=$meta;
		$new=~s/-XX-/$refresh/;

			open (FILE, "$basedir$room") || &unable("$basedir$room");			#open main chat file
			@contents=<FILE>;				#get contents
			close (FILE);

			open (FILE, ">$basedir$room") || &unable("$basedir$room");			#print again with notice that someone's been tossed
			foreach $line (@contents)
			{
				if ($line =~ /^<meta http-equiv\=/i)
				{
					print FILE "$new\n";
				}
				else
				{
					print FILE "$line";
				}
			}
			close (FILE);
		$go="$cgiurl3\?room\=$formdata{'room'}\&logon\=$formdata{'logon'}\&action\=Refresh\+Comment\+Window";
		print "Location: $go\n\n";
		exit 0;
	}
	else
	{
		$start = '<!--Do not edit past this line-->';

		if($formdata{'logon'} ne "$chatmaster")
		{
			open(FILE,"$basedir$userlist") || &unable("$basedir$userlist");
			@contents=<FILE>;
			close(FILE);

			$j=join('',@contents);
			if($j =~ /Chat Room Admin/)
			{
				$adminthere="yes";
			}

			foreach $line(@contents)
			{
				if($line =~ /$formdata{'logon'}/)
				{
					&speak;
				}
			}
		}
		else
		{
			&speak;
		}

		print "Content-type: text/html\n\n";
		print "<html><title>Nice Try</title>\n";
		print "<body bgcolor=\"\#ffffff\" text=\"\#000000\">\n";
		print "You have to be logged on in order to participate in the discussion\n";
		print "<p>\nClick <a href=\"$logonformurl\">here</a> to log on.\n";
		print "</html>\n";
		exit 0;

		sub speak {
			open(FILE,"$basedir$room") || &unable("$basedir$room");
			@contents=<FILE>;
			close (FILE);

			open(FILE,">$basedir$room") || &unable("$basedir$room");
			$numberoflines=0;
			foreach $line (@contents)
			{
				if($numberoflines eq $maxlines)
				{
					if($adminthere ne "yes")
					{
						close(FILE);
						&file_full;
					}
				}
				if ($line =~ /$start/)
				{
					print FILE "$line\n\n";
					if($formdata{'logon'} ne $chatmaster)
					{
						if($formdata{'image'} ne "NONE")
						{
							print FILE "<img src=\"$imageurl$formdata{'image'}\" align=middle><font color=\"\#ff0000\">$formdata{'logon'}:</font>";
						}
						else
						{
							print FILE "<font color=\"\#ff0000\">$formdata{'logon'}:</font>";
						}
					}
					else
					{
						if($formdata{'image'} ne "NONE")
						{
							print FILE "<img src=\"$imageurl$formdata{'image'}\" align=middle><font color=\"\#0000ff\">Chat Room Admin:</font>";
						}
						else
						{
							print FILE "<font color=\"\#0000ff\">Chat Room Admin:</font>";
						}
					}
					print FILE "$formdata{'comments'}<font size = -1>($time)</font>\n<p>";
				}
				else
				{
					print FILE "$line";
				}
				++$numberoflines;
			}
			close(FILE);

			&file_full;
		}
	}
}

sub file_full {

	$go="$cgiurl3\?room\=$formdata{'room'}\&logon\=$formdata{'logon'}\&action\=Refresh\+Comment\+Window";
	print "Location: $go\n\n";
	exit 0;
}

##########################################################################################
#Clear Screen
##########################################################################################

if ($formdata{'action'} eq "Clear Screen")		#clear the screen.
{
	&get_room;
	&get_users;

	$start = '<!--Do not edit past this line-->';

	open(FILE,"$basedir$room") || die "Content-type: text/html\n\n Could not open $basedir$room";			#open main chat file
	@contents=<FILE>;				#get contents
	close(FILE);

	if($save eq "yes")				#if chat dialogue is to be saved before clearing screen,
	{
		$filetmp=scalar localtime time;		#get date so we can save chat text
		@filetmp=split(/ /,$filetmp);		#as a file named by its date and time
		$filetmp=pop(@filetmp);
		$filename=join(//,@filetmp,".html");
	
		open(FILE,">$archive$filename") || &unable("$archive$filename");
		print FILE @contents;
		close(FILE);
	}

	open(FILE,">$basedir$room") || &unable("$basedir$room");
	foreach $line (@contents)			#print every line except comments(ie. just the header stuff and body tag, etc)
	{
		if ($line =~ /$start/)
		{
			$done="yes";
		}
		print FILE "$line";

		if ($done eq "yes")
		{
			print FILE "\n<center>\n<font color=\"\#0000ff\"><b>Screen cleared by The Chat Room Admin</b></font></center>\n";
			close (FILE);

			$loc="$cgiurl3\?room\=$formdata{'room'}\&logon\=$chatmaster\&action\=Refresh\+Comment\+Window";
			print "Location: $loc\n\n";
			exit 0;
		}
	}
}

##########################################################################################
#Redirect
##########################################################################################

if ($ENV{'QUERY_STRING'} =~ /exit/)
{
	@tmp=split(/=/,$ENV{'QUERY_STRING'});
	$url=$tmp[1];
	$url =~ s/\+/ /g;
	$url =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$url =~ s/~!/ ~!/g;
	$url =~ s/\%2F/\//g;
	print "Location: $url\n\n";
	exit 0;
}

##########################################################################################
#All else has failed
##########################################################################################

&go_away;

#################################################################################################
#Print the chat area screen--Chat subroutine
#################################################################################################

sub do_chat {

	$room=$formdata{'room'};

	print "Content-type: text/html\n\n";
	print "<html><title>$title</title>\n";
	print "<FRAMESET ROWS=\"\*\,100\">\n";

	print "<FRAMESET COLS=\"150\,\*\">\n";
	print "  <FRAME NAME=\"users\" SRC=\"$cgiurl3\?room\=$room\&logon\=$formdata{'logon'}\&action\=Refresh\+User\+List\">\n";
	print " <FRAMESET ROWS=\"150\,\*\">\n";
	print "  <FRAME NAME=\"private\" SRC=\"$cgiurl3\?logon\=$formdata{'logon'}\&action\=Check\+For\+New\+Messages\">\n";
	print "  <FRAME NAME=\"comments\" SRC=\"$cgiurl3\?room\=$room\&logon\=$formdata{'logon'}\&action\=Refresh\+Comment\+Window\">\n";
	print " </FRAMESET>\n";
	print "</FRAMESET>\n";

	print "<FRAMESET COLS=\"\*\">\n";
	print "<FRAME NAME=\"controls\" SRC=\"$cgiurl2\?room\=$room\&logon\=$formdata{'logon'}\&image\=$formdata{'image'}\">\n";
	print "</FRAMESET>\n";

	print "</FRAMESET>\n";

	print "<NOFRAMES>\n";
	print "<body bgcolor=\"\#ffffff\" text=\"\#000000\">\n";
	print "<html><title>Sorry</title>\n";
	print "You need a frames-capable browser to participate in the chat.\n";
	print "</NOFRAMES>\n";
	print "</html>\n";
	exit 0;
}

#################################################################################################
#Get the form data--Get form data subroutine
#################################################################################################

sub get_form_data {

	foreach $pair (@pairs)
	{
		@a = split(/\=/,$pair);
		$name=$a[0];
		$value=$a[1];
		$name =~ s/\+/ /g;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/~!/ ~!/g;
		$value =~ s/\+/ /g;
		push (@formdata,$name);
		push (@formdata,$value);
	}
	%formdata=@formdata;
	return %formdata;
}

sub name_taken {

	print "Content-type: text/html\n\n";
	print "<html><title>Error</title>\n";
	print "<body bgcolor=\"\#ffffff\" text=\"\#000000\">\n";
	print "Sorry.  The name <b>$formdata{'logon'}</b> is already being used.\n";
	print "<p>\nPlease go back and try a different logon.\n";
	print "</html>\n";
	exit 0;
}

sub get_room {

	foreach $key (keys(%rooms))
	{
		if ($formdata{'room'} eq $key)
		{
			$room=$rooms{$key};
			return $room;
		}
	}
}

sub get_users {

	foreach $key (keys(%users))
	{
		if ($formdata{'room'} eq $key)
		{
			$userlist=$users{$key};
			return $userlist;
		}
	}
}

sub unable{
	print "Content-type: text/html\n\n";
	print "<html>\n";
	print "<title>Error</title>\n";
	print "<body bgcolor=\"\#ffffff\" text=\"\#000000\">\n";
	print "Unable to open: $_[0]\n";
	print "</html>\n";
	exit 0;
}

sub go_away {
	print "Content-type: text/html\n\n";
	print "<html><title>Error</title>\n";
	print "<body bgcolor=\"\#ffffff\" text=\"\#000000\">\n";
	print "I'm sorry but you cannot access this script in the manner you just attempted.";
	print "<br>\nPlease use the <a href=\"$logonformurl\">logon form</a> to join the chat\n";
	print "</html>\n";
	exit 0;
}

sub wrong_pass {
	print "Content-type: text/html\n\n";
	print "<html><title>Error</title>\n";
	print "<body bgcolor=\"\#ffffff\" text=\"\#000000\">\n";
	print "Password incorrect.\n";
	exit 0;
}

#the end
