#!/usr/bin/perl

#################################################################################################
#chatfunc.pl
#
#This script handles all the special functions
#	-Refresh Comment Window
#	-Refresh User List
#	-Checking Private Messages
#	-Erasing Private Messages
#################################################################################################

#################################################################################################
#Configuration
#
#Everything is the same as in chat.pl
#
#	DISCLAIMER: I AM IN NO WAY RESPONSIBLE FOR ANY DAMAGE THIS SCRIPT MAY CAUSE TO 
#	            YOU OR ANYTHING DIRECTLY OR REMOTELY ASSOCIATED WITH YOU
#################################################################################################

$basedir='/home/httpd/elvis/public_html/chat4/';
$banishfile='banished.txt';
$addressfile='addresses.txt';
$logonformurl='http://linux.cqi.com.cn/~elvis/chat4';
$title="Oh Yeah Net's Chat Room";
$cgiurl='http://linux.cqi.com.cn/~elvis/chat4/chat.pl';
$cgiurl2='http://linux.cqi.com.cn/~elvis/chat4/chatctrl.pl';
$cgiurl3='http://linux.cqi.com.cn/~elvis/chat4/chatfunc.pl';
$chatmaster='elvis';
%rooms=('one','comments.html','two','comments2.html','three','comments3.html');
%users=('one','logon.html','two','logon2.html','three','logon3.html');
$privatedir = '/home/httpd/elvis/public_html/chat4/private/';

#################################################################################################
#Get the data from the query string
#################################################################################################

&check_mode;		#used for command-line debugging

if($mode eq "debug")
{
	push(@formdata,$ARGV[0],$ARGV[1],$ARGV[2],$ARGV[3],$ARGV[4],$ARGV[5],$ARGV[6],$ARGV[7]);
	%formdata = @formdata;
}
else
{
	@pairs = split(/\&/,$ENV{'QUERY_STRING'});
	foreach $pair (@pairs)
	{
		@a = split(/\=/,$pair);
		$name=$a[0];
		$value=$a[1];
		$name =~ s/\+/ /g;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/~!/ ~!/g;
		$value =~ s/\+/ /g;
		push (@formdata,$name,$value);
	}
	%formdata=@formdata;
}

#################################################################################################
#Refresh Windows
#################################################################################################

if ($formdata{'action'} eq "Refresh Comment Window")		#refresh comment window
{
	&get_room;
	&get_users;

	if($formdata{'logon'} ne $chatmaster)
	{
		open(FILE,"$basedir$userlist") || &unable("$basedir$userlist");
		@contents=<FILE>;
		close(FILE);
		foreach $line (@contents)
		{
			if($line =~ /($formdata{'logon'}<\/a><br>\n)$/)
			{
				$good = "yes";
			}
		}
	}

	if($good eq "yes" | $formdata{'logon'} eq $chatmaster)
	{
		open(FILE,"$basedir$room") || &unable("$basedir$room");
		@contents=<FILE>;
		close(FILE);
		print "Content-type: text/html\n\n";
		if(-e "$privatedir$formdata{'logon'}\.txt")
		{
			foreach $line (@contents)
			{
				if($line =~ /<!--Do not edit past this line-->/)
				{
					print $line;
					print "<p><center><table border=1><tr><td><center><font color=\"\#6E0000\"><b>There is an unread private message waiting for you.</b></font></td></tr></table></center><br>\n";
				}
				else
				{
					print $line;
				}
			}
		}
		else
		{
			print @contents;
		}
		exit 0;
	}
	else
	{
		&error_message;
		exit 0;
	}
}

if ($formdata{'action'} eq "Refresh User List")			#refresh list of users logged on
{
	&get_room;
	&get_users;

	if($formdata{'logon'} ne $chatmaster)
	{
		open(FILE,"$basedir$userlist") || &unable("$basedir$userlist");
		@contents=<FILE>;
		close(FILE);
		foreach $line (@contents)
		{
			if($line =~ /($formdata{'logon'}<\/a><br>\n)$/)
			{
				$good = "yes";
			}
		}
	}

	if($good eq "yes" | $formdata{'logon'} eq $chatmaster)
	{
		open(FILE,"$basedir$userlist") || &unable("$basedir$userlist");
		print "Content-type: text/html\n\n";
		print <FILE>;
		close(FILE);
		exit 0;
	}
	else
	{
		&error_message;
		exit 0;
	}
}

##########################################################################################
#Check Private Messages
##########################################################################################

if ($formdata{'action'} eq "Check For New Messages")	#check private message file for new messages
{
	open(FILE,"$privatedir$formdata{'logon'}\.html");
	@contents=<FILE>;
	close(FILE);

	unlink("$privatedir$formdata{'logon'}\.txt");

	print "Content-type: text/html\n\n";
	print @contents;
	exit 0;
}

##########################################################################################
#Erase All Messages
##########################################################################################

if ($formdata{'action'} eq "Erase All Messages")	#erase private messages
{
	open(FILE,">$privatedir$formdata{'logon'}\.html");
	print FILE "<html>\n";
	print FILE "<title>Your Private Messages</title>\n";
	print FILE "<body bgcolor=\"\#ffffff\" text=\"\#000000\">\n";
	print FILE "<center><h2>Private Messages</h2></center><br>\n";
	print FILE "<center><form method=get action=\"$cgiurl3\" target=\"private\">\n";
	print FILE "<input type=submit name=\"action\" value=\"Check For New Messages\">\n";
	print FILE "<input type=submit name=\"action\" value=\"Erase All Messages\">\n";
	print FILE "<input type=hidden name=\"logon\" value=\"$formdata{'logon'}\">\n";
	print FILE "</form></center><br>\n";
	print FILE "</html>\n";
	close(FILE);

	print "Content-type: text/html\n\n";
	open(FILE,"$privatedir$formdata{'logon'}\.html");
	@contents=<FILE>;
	close(FILE);
	
	print @contents;
	exit 0;
}

#################################################################################################
#Subroutines
#################################################################################################

sub get_room {

	foreach $key (keys(%rooms))
	{
		if ($formdata{'room'} eq $key)
		{
			$room=$rooms{$key};
			return $room;
		}
	}
}

sub get_users {

	foreach $key (keys(%users))
	{
		if ($formdata{'room'} eq $key)
		{
			$userlist=$users{$key};
			return $userlist;
		}
	}
}

sub error_message {

	print "Content-type: text/html\n\n";
	print "<html>\n<title>Nice Try</title>\n";
	print "<body bgcolor=\"\#ffffff\" text=\"\#000000\">\n";
	print "You have either been kicked out or logged out.  In order to take part \n";
	print "in the discussion you must be logged in.\n";
	print "</html>\n";
	exit 0;
}

sub check_mode {

	$mode = "real";
	return $mode;
}

sub unable{
	print "Content-type: text/html\n\n";
	print "<html>\n";
	print "<title>Error</title>\n";
	print "<body bgcolor=\"\#ffffff\" text=\"\#000000\">\n";
	print "Unable to open: $_[0]\n";
	print "</html>\n";
	exit 0;
}

#the end

